// PoVRay 3.6/3.7 Include File "Table_t00.inc"
// author: Friedrich A. Lohmueller, Dec-2009, May-2014
// homepage: http://www.f-lohmueller.de  
// email: Friedrich.Lohmueller_AT_t-online.de

#ifndef( Table_t00_Inc_Temp)
#declare Table_t00_Inc_Temp = version;
#version 3.6;

#ifndef(  Colors_Inc_Temp)
#include "colors.inc"                                             
#end
#ifndef(  Textures_Inc_Temp)
#include "textures.inc"                                             
#end
#ifndef(  Shapes_Inc_Temp)
#include "shapes.inc"                                             
#end

//--------------------------------------------------------------------
#macro Table_t00 ( Table__Height, 
                   Table__Half_Width_X, 
                   Table__Half_Width_Z, 
                   Table__Feet_Radius, 
                   Table__Plate_D, 
                   Table__Plate_Overhang, 
                   Merge_On,  // 
                 ) //-------------------------------------------------
//------------------------------------ default textures
                                             
#ifndef( Table_Plate_Texture  )

   #ifndef ( Woods_Inc_Temp )
   #include "woods.inc"
   #end
//-------------------------------------------------------------
#declare T_Wood  =
  texture{ pigment{ P_WoodGrain15A color_map { M_Wood15A }
                    warp{ black_hole <0,0,0>,0.2
                          falloff 2         strength 2
                          repeat <.45,0,.5>  turbulence<.05,0,.1>
                          inverse} // end warp
         }}
  texture{ pigment{ P_WoodGrain15B color_map { M_Wood15B }
                    warp{ black_hole <0,0,0>,0.2
                          falloff 2         strength 2
                          repeat <.45,0,.5>  turbulence<.05,0,.1>
                          inverse}
         }}
//-------------------------------------------------------------
#declare Random_1=seed(7) ;
#declare T_1 = texture{ T_Wood 
                        rotate (1+1*rand(Random_1))*x
                        scale (1+1*rand(Random_1))
                        translate (50*rand(Random_1))*x
                        finish{ phong 1 reflection{ 0.05}}
                      } // end texture
// ------------------------------------------------------------   
#declare Table_Plate_Texture =
  texture{ gradient <1,0,0>
           scale 1.5 // turbulence 0.1
           texture_map {
             [0.00 T_1]
             [0.50 T_1]
             [0.50 T_1 translate <4,0,0>]
             [1.00 T_1 translate <4,0,0>]
                        }// end of texture_map
           scale <0.2,0.2,1>*0.25
        } // end of texture -----------------------------------   
#end //
// ------------------------------------------------------------   
#ifndef( Table_Feet_Texture  )
#declare Table_Feet_Texture = 
 texture{ Polished_Chrome } 
#end //  
// ------------------------------------------------------------
// ------------------------------------------------------------
// ------------------------------------------------------------

#local CR = Table__Feet_Radius; 
#local CX = Table__Half_Width_X - CR; 
#local CZ = Table__Half_Width_Z - CR; 
#local PV = Table__Plate_Overhang; 
#local PH = Table__Plate_D; 

#local SH = Table__Height - PH-CR; 

#local SX = Table__Half_Width_X ; 
#local SZ = Table__Half_Width_Z ; 
#local ST = 2*CR ; 


// ------------------------------------------------------------
union{ // total union

union{
 // feet
 cylinder { <0,0,0>,<0,SH,0>, CR translate< CX,0,-CZ> } 
 cylinder { <0,0,0>,<0,SH,0>, CR translate<-CX,0,-CZ> }
 cylinder { <0,0,0>,<0,SH,0>, CR translate< CX,0, CZ> }
 cylinder { <0,0,0>,<0,SH,0>, CR translate<-CX,0, CZ> }
 // top frame 
 cylinder { <-CX,0,  0>,< CX,0, 0>, CR  translate<0,SH, CZ> }
 cylinder { <-CX,0,  0>,< CX,0, 0>, CR  translate<0,SH,-CZ> }
 cylinder { <  0,0,-CZ>,<  0,0,CZ>, CR  translate< CX,SH,0> }
 cylinder { <  0,0,-CZ>,<  0,0,CZ>, CR  translate<-CX,SH,0> }
 // corners
 sphere{ < CX,SH,-CZ>, CR  } 
 sphere{ <-CX,SH,-CZ>, CR  } 
 sphere{ < CX,SH, CZ>, CR } 
 sphere{ <-CX,SH, CZ>, CR } 

texture{ Table_Feet_Texture }
}// end of union

// seat
object{ // Round_Box(A, B, WireRadius, UseMerge) --- 
        Round_Box(<-SX-PV,0,-SZ-PV>,<SX+PV,PH,CZ+PV>, CR/5,0)  
        texture{ Table_Plate_Texture }
        translate<0,SH+CR,0>
      } // ------------------------------------------
}// end of total union
#end  
//-------------------------------- end of #macro Table_t10 (...) 
// sample: 
/*
//-------------------------------------------------------------- 
//------------------------------------------- optional textures
#declare Table_Plate_Texture = 
 texture{ DMFDarkOak
          normal { wood 0.5 scale 0.3 turbulence 0.1}
          finish { phong 1 } 
          translate<0,2,0>  rotate< 0,0,0> scale 0.08
        } // end of texture 
#declare Table_Feet_Texture = 
 texture{ Polished_Chrome  } // end of texture 
//-------------------------------------------------------------- 
#include "Table_t00.inc"
object{ Table_t00 ( 0.60, // Table__Height, 
                    0.40, // Table__Half_Width_X, 
                    0.60, // Table__Half_Width_Z, 
                    0.015,//Table__Feet_Radius, 
                    0.02, // Table__Plate_D, 
                    0.03, // Table__Plate_Overhang, 
                    0, // Merge_On, for glas plate use 1
                  ) //------------------------------------------
        scale <1,1,1> rotate<0,0,0> translate< 0.00,0.00,0.00>}
//-------------------------------------------------------------- 
//-------------------------------------------------------------- 


*/ 

#version Table_t00_Inc_Temp;
#end
//------------------------------------- end of include file
